header
{
/**
 * Semantic analysis for the Mile++ Language.
 * 
 * @author Ricardo Soto
 * @since 1.5
 */

package cl.ucv.inf.mileppcompiler.compilers;

}

  
class MilePPTreeParser extends TreeParser;
options
{
    importVocab=MilePPParserVocab;
    buildAST = false;
    defaultErrorHandler=false;
}

{
private SemanticInspector   sI = new SemanticInspector();
}

//==================================================
//Program

program  : #(PROGRAM main_class_dec (class_dec)*);


//======================================================= 
//Class declarations
        
main_class_dec : #(MAIN_RW class_dec);


class_dec : #(CLASS_RW id1:IDENT {sI.addClass(id1);} 
             (EXTENDS_RW IDENT)? 
             (param)? class_body);

param :  #(PARAM type IDENT (COMMA type IDENT)*);
         
class_body : #(BODY var_dec method_dec);


//=======================================================
// Var dec

var_dec : #(VAR_DEC (basic_var_dec| object_dec)*);

basic_var_dec : #(BASIC_VAR_DEC basic_type IDENT);

object_dec : #(OBJECT_RW IDENT IDENT);
          
type:     basic_type|IDENT;

basic_type:   (NUMERIC_TYPE|STRING_TYPE) ;

//=======================================================
// Method dec

method_dec : ;               
        
        
         
//=================================================
//Expressions

expr
  : #(OR_RW           expr expr) 
  | #(AND_RW          expr expr) 
  | #(EQUAL           expr expr) 
  | #(GR_EQUAL        expr expr)  
  | #(NOT_EQUAL       expr expr) 
  | #(GR              expr expr) 
  | #(LE              expr expr) 
  | #(PLUS            expr expr) 
  | #(SUB             expr expr) 
  | #(STAR            expr expr) 
  | #(SLASH           expr expr) 

  | #(UN_MINUS                   expr)
  | #(RES_NOT                    expr) 
  | IDENT 
  | lit
  ;

  lit: REAL_LITERAL|INT_LITERAL;